using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using AddinExpress.OL;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace adx_ol_cs_formRegionVisibility
{
    public partial class frmInspectorRegion : AddinExpress.OL.ADXOlForm
    {
        public frmInspectorRegion()
        {
            InitializeComponent();
        }

        private Outlook.MailItem GetCurrentMail()
        {
            if (this.InspectorObj != null)
            {
                Outlook.Inspector inspector = this.InspectorObj as Outlook.Inspector;
                if (inspector != null)
                {
                    object currentItem = inspector.CurrentItem;
                    Outlook.MailItem mail = currentItem as Outlook.MailItem;
                    if (mail != null)
                    {
                        return mail;
                    }
                    else
                    {
                        if (currentItem != null)
                        {
                            Marshal.ReleaseComObject(currentItem);
                        }
                        return null;
                    }
                }
            }
            return null;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Outlook.MailItem mail = GetCurrentMail();
            if (mail != null)
            {
                try
                {
                    if ((AddinModule as AddinModule).HostMajorVersion < 11)
                        MessageBox.Show("In Outlook 2000 SP1 and Outlook XP, accessing some fields triggers the Outlook Security Guard",
                            "Controlling the Form Visibility", MessageBoxButtons.OK, MessageBoxIcon.None);
                    if (listBox1.SelectedItem != null)
                        mail.To = listBox1.SelectedItem.ToString();
                }
                finally
                {
                    Marshal.ReleaseComObject(mail);
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Outlook.MailItem mail = GetCurrentMail();
            if (mail != null)
            {
                try
                {
                    if (listBox2.SelectedItem != null)
                        mail.Subject = listBox2.SelectedItem.ToString();
                }
                finally
                {
                    Marshal.ReleaseComObject(mail);
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if ((AddinModule as AddinModule).HostMajorVersion == 12)
            {
                // button in MailCompose ribbon
                (AddinModule as AddinModule).adxRibbonButton1.Enabled = true;
                // button in MailRead ribbon
                (AddinModule as AddinModule).adxRibbonButton2.Enabled = true;
            }
            else
                (AddinModule as AddinModule).adxInspectorCommandBarButton1.Enabled = true;
            this.Hide();
        }
    }
}
